/* vim:set ts=2 sw=2 sts=2 tw=80 et cindent: */
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is
 * Christopher Blizzard.
 * Portions created by the Initial Developer are Copyright (C) 2001
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Oleg Romashin <romaxa@gmail.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

#ifndef __EmbedMicrobObserver_h
#define __EmbedMicrobObserver_h

#include "EmbedPrivate.h"
#include "nsIObserver.h"

// {a5bbe517-5549-492a-a43e-d09cdd42ee43}  
#define NS_EMBED_MICROB_OBSERVER_CID \
{ 0xa5bbe517, 0x5549, 0x492a, { 0xa4, 0x3e, 0xd0, 0x9c, 0xdd, 0x42, 0xee, 0x43} }

#define NS_EMBED_CLIENT_OBSERVER_CONTRACTID "@browser/engine-client-observer;1"

class EmbedMicrobObserver : public nsIObserver
{
  public:
    NS_DECL_ISUPPORTS
    NS_DECL_NSIOBSERVER

    static NS_METHOD Create (nsISupports * aOuter, REFNSIID aIID,
                             void **aResult);

    static NS_METHOD RegisterSelf (nsIComponentManager * aCompMgr,
                                   nsIFile * aPath,
                                   const char *aLoaderStr,
                                   const char *aType,
                                   const nsModuleComponentInfo * aInfo);
    static NS_METHOD UnregisterSelf(nsIComponentManager* aCompMgr,                                                                                                      
                                    nsIFile* aPath, const char *aLoaderStr,                                                                                                         
                                    const nsModuleComponentInfo *aInfo);

    NS_DEFINE_STATIC_CID_ACCESSOR (NS_EMBED_MICROB_OBSERVER_CID)
  private:

    EmbedMicrobObserver ();
    ~EmbedMicrobObserver ();

    nsresult Init ();

    nsresult CleanAuthData ();
};

#endif /* __EmbedMicrobObserver_h */
